import { ESLint } from 'eslint';
import 表格构造器 from 'cli-table3';
import 粉笔 from 'chalk';
import ora from 'ora';
import { 获取函数名和复杂度 } from './_utils.mjs';

let 文件复杂度列表 = [];

const 圈层复杂度 = async () => {
  文件复杂度列表 = [];

  const cli = new ESLint({
    errorOnUnmatchedPattern: false,
    extensions: ['*.jsx', '*.tsx'],
    overrideConfig: {
      parserOptions: {
        ecmaVersion: 6,
        sourceType: 'module',
        ecmaFeatures: {
          globalReturn: true,
          impliedStrict: true,
          jsx: true,
        },
      },
      rules: { complexity: ['error', { max: 1 }] },
    },
  });
  const 加载中 = ora('扫描中...');
  加载中.start();
  const 所有文件检查报告 = await cli.lintFiles(['src/**']);

  for (let 文件下标 = 0; 文件下标 < 所有文件检查报告.length; 文件下标++) {
    const 单个文件检查报告 = 所有文件检查报告[文件下标];
    const { filePath: 文件路径, messages: 消息列表 } = 单个文件检查报告;

    for (let 消息下标 = 0; 消息下标 < 消息列表.length; 消息下标++) {
      const 单个消息 = 消息列表[消息下标];
      const {
        message: 错误信息,
        ruleId: 规则id,
        line: 开始行,
        endLine: 结束行,
      } = 单个消息;

      if (规则id === 'complexity') {
        const { 函数名, 复杂度 } = 获取函数名和复杂度(错误信息);
        if (复杂度 > 20) {
          const 切割文件路径 = `src${文件路径.split('src')[1]}`;
          文件复杂度列表.push([切割文件路径, 函数名, 复杂度, 开始行, 结束行]);
        }
      }
    }
  }

  加载中.stop();

  const 表格数据 = new 表格构造器({
    head: ['文件路径', '函数名', '复杂度', '开始行', '结束行'],
  });

  文件复杂度列表.sort((before, after) => {
    return before[2] - after[2];
  });

  表格数据.push(...文件复杂度列表);
  console.log(表格数据.toString());
  console.log(
    粉笔.green(
      `超出限制复杂度的文件个数为：${粉笔.red(文件复杂度列表.length)} 个`,
    ),
  );
};

export default 圈层复杂度;
