import fs from 'fs';
import path from 'path';
import ora from 'ora';
import 咨询台 from 'inquirer';
import 提示用户输入 from 'prompts';
import 表格构造器 from 'cli-table3';
import 粉笔 from 'chalk';
import { program } from 'commander';
import { 代码行数选项配置 } from '../config.mjs';

const 扫描文件结果列表 = [];

let 行数限制 = 0;

function 扫描文件内容(文件路径) {
  const 文件内容 = fs.readFileSync(文件路径, 'utf-8');
  const 文件行数 = 文件内容.split('\n').length;

  if (文件行数 > 行数限制) {
    扫描文件结果列表.push([文件路径, 文件行数]);
  }
}

//查找 js｜jsx｜ts｜tsx文件
function 扫描文件夹(开始路径) {
  const 文件列表 = fs.readdirSync(开始路径);

  文件列表.forEach((文件名) => {
    const 文件路径 = path.join(开始路径, 文件名);
    const 是文件夹 = fs.statSync(文件路径).isDirectory();

    const 文件名是否需要忽略 =
      文件名[0] === '.' ||
      ['dist', 'yarn.lock', 'node_modules'].includes(文件名);
    if (是文件夹 && !文件名是否需要忽略) {
      扫描文件夹(文件路径);
    }
    if (文件路径.match(/\.(cjs|mjs|js|jsx|ts|tsx)$/) && !文件名是否需要忽略) {
      扫描文件内容(文件路径);
    }
  });
}

const 扫描当前文件夹内代码 = async () => {
  const { 行数 } = await 咨询台.prompt([
    {
      type: 'list',
      name: '行数',
      message: '扫描当前路径下所有大于该行数的文件',
      choices: 代码行数选项配置,
    },
  ]);

  if (行数 === '自定义') {
    const { 用户输入的行数 } = await 提示用户输入({
      type: 'number',
      name: '用户输入的行数',
      message: '请输入代码行数',
    });
    行数限制 = 用户输入的行数;
  } else {
    行数限制 = 行数;
  }
  const 加载中 = ora('扫描中...');
  加载中.start();

  await 扫描文件夹('./');

  加载中.stop();

  const 表格数据 = new 表格构造器({
    head: ['文件路径', '文件行数'],
  });
  表格数据.push(...扫描文件结果列表);

  console.log(表格数据.toString());
  console.log(
    粉笔.green(
      `超出洗限制行数的文件个数为：${粉笔.red(扫描文件结果列表.length)} 个`,
    ),
  );
};

export default 扫描当前文件夹内代码;
